<?php

namespace Litecms\Memo\Policies;

use Litecms\Memo\Models\Memo;
use Illuminate\Foundation\Auth\User as Authenticatable;

trait MemoAction
{

    /**
     * Determine if the given user can copy the given memo.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    public function copy(Authenticatable $user, Memo $memo)
    {

        if ($authUser->canDo('memo.memo.action.copy')) {
            return true;
        }

        $this->model->is_owner;
    }

    /**
     * Determine if the given user can empty the given memo.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    function empty(Authenticatable $user, Memo $memo) {

        if ($authUser->canDo('memo.memo.action.empty')) {
            return true;
        }

        $this->model->is_owner;
    }

    /**
     * Determine if the given user can transfer the given memo.
     *
     * @param Authenticatable $user
     *
     * @return bool
     */
    public function transfer(Authenticatable $user, Memo $memo)
    {

        if ($authUser->canDo('memo.memo.action.transfer')) {
            return true;
        }

        $this->model->is_owner;
    }

}
